//
//  DataStorage.swift
//  calculator-history
//
//  Created by Илья Лошкарёв on 03.03.2018.
//  Copyright © 2018 SFEDU. All rights reserved.
//

class DataStorage<T> {
    private var data = [T]()
    
    subscript(index: Int) -> T {
        return data[index]
    }
    
    var count: Int { return data.count }
    
    func remove(at index: Int) {
        data.remove(at: index)
    }
    
    func append(_ element: T) {
        data.append(element)
    }
    
    func clear() {
        data.removeAll()
    }
}
