//
//  HistoryCalculator.swift
//  calculator-history
//
//  Created by Илья Лошкарёв on 03.03.2018.
//  Copyright © 2018 SFEDU. All rights reserved.
//

/// Запись об одной операции
struct CalculatorRecord {
    let leftValue: Double
    let operation: Operation
    let rightValue: Double
    let result: Double?  // в случае ошибки result == nil
}

/// Протокол калькулятора с историей
/// При вычислении любой операции, калькулятор
/// должен записывать данные в хранилище history
protocol HistoryCalculator: Calculator {
    /// Массив записей истории
    weak var history: DataStorage<CalculatorRecord>! { get }
    
    /// Инициализатор
    /// `len` – максимальное количество символов в поле ввода
    /// `frac` – максимальное количество знаков после запятой
    init(inputLength len: UInt, fractionLength frac: UInt, historyStorage store: DataStorage<CalculatorRecord>)
}
